; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  2009 Warp
; -------------------------------------------------------------------------
; Title         : Warp HFS Comment Editor
; Description   : Tool for HTTP File Server (HFS) - http://www.rejetto.com/hfs
; Version       : 0.27 final
; Date          : 16.01.2009
; Company       : Warp
; Author        : Warp
; Homepage      : http://warp2001.dyndns.org:44792
;               : Online 18:00 - 21:00 GMT+1
; Email         : ge2001@yahoo.com
; -------------------------------------------------------------------------
; Assembler     : Microsoft Assembler 6.14.884 / Linker 5.12.8078 / Resource Compiler 5.00.1823.1
;               : ml.exe /c /coff Warp_HFS-CE.asm
;               : rc.exe /v rsrc.rc
;               : cvtres.exe /machine:ix86 rsrc.res
;               : link.exe /SUBSYSTEM:WINDOWS /OPT:NOREF Warp_HFS-CE.obj rsrc.res
; -------------------------------------------------------------------------
; Comments      : Freeware, use it on your own risk
;               : To enable icons search for: remove ";" to enable icons
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.586
.MMX
.Model Flat, StdCall
option casemap:none

include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc

include \masm32\include\ole32.inc
include \masm32\include\shell32.inc
include \masm32\include\shlwapi.inc
;---
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib

includelib \masm32\lib\ole32.lib 
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\shlwapi.lib
;---
include \masm32\include\windows.inc

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP_CallBack         equ [ebp+04]                        ; return address
WP_hWnd             equ [ebp+08]                        ; handle window for msg
WP_uMsg             equ [ebp+12]                        ; message number
WP_wParam           equ [ebp+16]                        ; extra message info
WP_lParam           equ [ebp+20]                        ; extra message info
;---
MAX_PATHEX          equ 1024
MaxBufferTmp        equ 65535
UseBufferTmp        equ MaxBufferTmp-MAX_PATHEX-MAX_PATHEX-1

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wc                  WNDCLASSEX <>                       ; Structures
msg                 MSG <>
icc                 INITCOMMONCONTROLSEX <>
lvc                 LV_COLUMN <>
lvi                 LV_ITEM <>
lvbki               LVBKIMAGE <>
wfd                 WIN32_FIND_DATA <>
bi                  BROWSEINFO <>
pt                  POINT <>
;---
hBr0000D6FFh        dd ?                                ; Brush
;---
hFntDefGui          dd ?                                ; Handle
hWndIL              dd ?
hWndLV              dd ?
hWndCBDir           dd ?
hWndCBSymbol        dd ?
hWndCBCustom        dd ?
hWndED              dd ?
hWndBU_Folder       dd ?
hWndBU_InsertSymbol dd ?
hWndBU_InsertCustom dd ?
hWndBU_DeleteDir    dd ?
hWndBU_DeleteCustom dd ?
hWndBU_SaveComment  dd ?
hWndBU_ModeSingle   dd ?
hWndBU_ModeMulti    dd ?
hWndBU_ModeBAK      dd ?
hWndSB              dd ?
hSysMenu            dd ?
hPopup              dd ?
hMem                dd ?
hFile               dd ?
hFindFile           dd ?
;---
FileSizeLow         dd ?                                ; Var's
FileSizeHigh        dd ?
FileBytesTotal      dd ?
FileBytesRead       dd ?
FileBytesWrite      dd ?
hInstance           dd ?
ReturnEAX           dd ?
pMem                dd ?
counter             dd ?
fMode               dd ?
IconIndex           dw ?
;---
BufferPath          db MAX_PATHEX   dup (?)             ; Buffer
BufferProgramDir    db MAX_PATHEX   dup (?)
BufferProgramFuc    db MAX_PATHEX   dup (?)
BufferPathFile      db MAX_PATHEX   dup (?)
BufferLVText        db MAX_PATHEX   dup (?)
BufferInsert        db MaxBufferTmp dup (?)
BufferTmp           db MaxBufferTmp dup (?)
BufferTmp1          db MaxBufferTmp dup (?)

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
align 8
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
XorgWindow          dd 0
YorgWindow          dd 0
XmaxWindow          dd 720
YmaxWindow          dd 520
;---
szCN                db "7srejhfrsei6kedr424pio843wsrfklwjj4254r34po9p21jk2409rmmjew4",0  ; Strings
szWN                db "  2009 Warp - HTTP File Server Comment Editor 0.27 final - ",0
;---
szCN_Listview       db "SysListView32",0
szCN_Statusbar      db "msctls_statusbar32",0
szCN_Combobox       db "COMBOBOX",0
szCN_Edit           db "EDIT",0
szCN_Button         db "BUTTON",0
;---
szbuildtime         db "%build-time%",0
szcomment           db "%comment%",0
szconnections       db "%connections%",0
szcontent           db "%content%",0
szdiskfree          db "%diskfree%",0
szdonebytes         db "%done-bytes%",0
szencodedfolder     db "%encoded-folder%",0
szfilename          db "%filename%",0
szfiles             db "%files%",0
szfolder            db "%folder%",0
szhost              db "%host%",0
szidx               db "%idx%",0
szip                db "%ip%",0
szitemadded         db "%item-added%",0
szitemarchivable    db "%item-archivable%",0
szitemcomment       db "%item-comment%",0
szitemdlcount       db "%item-dl-count%",0
szitemext           db "%item-ext%",0
szitemmodified      db "%item-modified%",0
szitemname          db "%item-name%",0
szitemsize          db "%item-size%",0
szitemsizeb         db "%item-size-b%",0
szitemsizekb        db "%item-size-kb%",0
szitemurl           db "%item-url%",0
szlist              db "%list%",0
szloggedin          db "%loggedin%",0
szloginlink         db "%login-link%",0
sznew               db "%new%",0
sznumber            db "%number%",0
sznumberaddresses   db "%number-addresses%",0
sznumberaddrdownloa db "%number-addresses-downloading%",0
sznumberaddressesev db "%number-addresses-ever%",0
sznumberfiles       db "%number-files%",0
sznumberfolders     db "%number-folders%",0
szparentfolder      db "%parent-folder%",0
szperc              db "%perc%",0
szprogressfiles     db "%progress-files%",0
szreason            db "%reason%",0
szsequential        db "%sequential%",0
szspeedin           db "%speed-in%",0
szspeedkb           db "%speed-kb%",0
szspeedout          db "%speed-out%",0
szstyle             db "%style%",0
sztimestamp         db "%timestamp%",0
sztotalbytes        db "%total-bytes%",0
sztotalin           db "%total-in%",0
sztotalout          db "%total-out%",0
sztotalsize         db "%total-size%",0
szup                db "%up%",0
szuploadfiles       db "%upload-files%",0
szuploadlink        db "%upload-link%",0
szuptime            db "%uptime%",0
szuser              db "%user%",0
szversion           db "%version%",0
;---
szModeBAK           db "Backup Comment(s)",0
szDirtxt            db "\dir.txt",0
szFuctxt            db "\fuc.txt",0
szBAK               db ".BAK",0
szOpen              db "open",0
szWildCtrl          db "\*",0
szInsertSymbol      db "Insert Symbol",0
szInsertCustom      db "Insert Custom",0
szDelete            db "Delete",0
szSaveComment       db "Save Comment(s)",0
szModeSingle        db "Single Comment",0
szModeMulti         db "Multiple Comment",0
szSelectFolder      db "Select Folder",0
szExtensionComment  db ".comment",0
szExtensionCommentB db ".comment.BAK",0
szhfscommentstxt    db "hfs.comments.txt",0
szhfscommentstxtB   db "hfs.comments.txt.BAK",0
szInsertSelected    db "Insert selected",0
szInsertSelectedLB  db "Insert selected and add line break",0
szInsertAll         db "Insert all with line break",0
szInsertNew         db "Scan and insert new with line break",0
szInsertFromSelect  db "Insert all from selected with line break",0
szExecuteFile       db "Execute File",0
szCancel            db "Cancel",0
szEqual             db "=",0
szLineBreak         db 0Dh,0Ah,0
szAttention0        db "0. Attention please !",0
szAttention1        db "1. Comment Editor for HTTP File Server (HFS).",0
szAttention2        db "2. This software is freeware.",0
szAttention3        db "3. The programmer is not responsible for the usage of this software.",0
szAttention4        db "4. It is your task to take care of the action you perform, always backup your software.",0
szAttention5        db "5. You accept this agreement if you continue using this software !",0
szAbout             db "About",0
szHFSHome           db "HFS Homepage",0
szWarpHome          db "Warp Homepage",0
szURLHFS            db "http://www.rejetto.com/hfs",0
szURLWarp           db "http://warp2001.dyndns.org:44792",0
szErrorFileSize     db "The size of the file is Null or to big.",0
szAboutText         db "  2009 Warp - Comment Editor for HTTP File Server (HFS) - Done in January 2009 by Warp - Freeware",0



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code
align 8
Main:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetModuleHandle,0
mov     wc.hInstance,eax
mov     hInstance,eax
;---
invoke  CoInitialize,0
;---
;finit                                           ; init FPU
;---
invoke  FindWindow,ADDR szCN,ADDR szWN
cmp     eax,0h
je      RunProgram
mov     ebx,eax
;---
invoke  ShowWindow,ebx,SW_SHOWNORMAL
invoke  SetForegroundWindow,ebx
jmp     TerminateProgram
;---
RunProgram:
mov     icc.dwSize,sizeof INITCOMMONCONTROLSEX
mov     icc.dwICC,ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES
invoke  InitCommonControlsEx,ADDR icc
;---
call    SubGetSystemMetrics
;---
invoke  LoadIcon,wc.hInstance,20000
mov     wc.hIconSm,eax
mov     wc.hIcon,eax
invoke  LoadCursor,0,IDC_ARROW
mov     wc.hCursor,eax
mov     wc.hbrBackground,COLOR_BTNFACE+1
mov     wc.cbSize,sizeof WNDCLASSEX
mov     wc.style,CS_HREDRAW or CS_VREDRAW
mov     wc.lpfnWndProc,OFFSET WP
mov     wc.cbClsExtra,0
mov     wc.cbWndExtra,0
mov     wc.lpszMenuName,0
mov     wc.lpszClassName,OFFSET szCN
invoke  RegisterClassEx,ADDR wc
;---
invoke  CreateWindowEx,0,ADDR szCN,ADDR szWN,WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_MINIMIZEBOX,XorgWindow,YorgWindow,XmaxWindow,YmaxWindow,0,0,wc.hInstance,0
mov     msg.hwnd,eax
invoke  ShowWindow,msg.hwnd,SW_SHOWNORMAL
invoke  UpdateWindow,msg.hwnd



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MessageLoop:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
invoke  GetMessage,ADDR msg,0,0,0
cmp     eax,0h
je      TerminateProgram
invoke  TranslateMessage,ADDR msg
invoke  DispatchMessage,ADDR msg
jmp     MessageLoop
; -------------------------------------------------------------------------
TerminateProgram:
invoke  CoUninitialize
invoke  ExitProcess,wc.hInstance
mov     eax,msg.wParam
ret



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WP:
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push    ebp
mov     ebp,esp
pushad
mov     eax,WP_uMsg
; -------------------------------------------------------------------------
WP_WM_CREATE:
cmp     eax,WM_CREATE
jne     WP_WM_DESTROY
; -------------------------------------------------------------------------
invoke  GetCurrentDirectory,MAX_PATHEX,ADDR BufferProgramDir
invoke  lstrcat,ADDR BufferProgramDir,ADDR szDirtxt
invoke  GetCurrentDirectory,MAX_PATHEX,ADDR BufferProgramFuc
invoke  lstrcat,ADDR BufferProgramFuc,ADDR szFuctxt
invoke  CreateSolidBrush,0000D6FFh
mov     hBr0000D6FFh,eax
invoke  GetStockObject,DEFAULT_GUI_FONT
mov     hFntDefGui,eax
invoke  SendMessage,WP_hWnd,WM_SETFONT,hFntDefGui,1
call    SubCreateSysMenu
call    SubCreateCBDir
call    SubCreateLV
call    SubCreateCBSymbol
call    SubCreateCBCustom
call    SubCreateEdit
call    SubCreateBU_DeleteDir
call    SubCreateBU_Folder
call    SubCreateBU_InsertSymbol
call    SubCreateBU_InsertCustom
call    SubCreateBU_DeleteCustom
call    SubCreateBU_ModeSingle
call    SubCreateBU_ModeMulti
call    SubCreateBU_SaveComment
call    SubCreateBU_ModeBAK
call    SubCreateSB
call    SubCreatePopupMenu
call    SubLoadFuc
call    SubLoadDir
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DESTROY:
cmp     eax,WM_DESTROY
jne     WP_WM_SYSCOMMAND
; -------------------------------------------------------------------------
invoke  PostQuitMessage,0
popad
xor     eax,eax
mov     esp,ebp
pop     ebp
ret     10h

; -------------------------------------------------------------------------
WP_WM_SYSCOMMAND:
cmp     eax,WM_SYSCOMMAND
jne     WP_WM_SIZE
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,SC_CLOSE
jne     WM_SYSCOMMAND_HFS
invoke  AnimateWindow,WP_hWnd,500,AW_HIDE or AW_BLEND
call    SubSaveDir
call    SubSaveFuc
call    SubCleanSystem
jmp     WP_Return
;---
WM_SYSCOMMAND_HFS:
cmp     ax,1050
jne     WP_WM_SYSCOMMAND_Warp
invoke  SetWindowText,hWndSB,0
invoke  ShellExecute,WP_hWnd,0,ADDR szURLHFS,0,0,0
cmp     eax,32
ja      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_SYSCOMMAND_Warp:
cmp     ax,1051
jne     WP_WM_SYSCOMMAND_About
invoke  SetWindowText,hWndSB,0
invoke  ShellExecute,WP_hWnd,0,ADDR szURLWarp,0,0,0
cmp     eax,32
ja      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_SYSCOMMAND_About:
cmp     ax,1052
jne     WP_Return
invoke  SetWindowText,hWndSB,ADDR szAboutText
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_SIZE:
cmp     eax,WM_SIZE
jne     WP_WM_PAINT
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_PAINT:
cmp     eax,WM_PAINT
jne     WP_WM_NOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NOTIFY:
cmp     eax,WM_NOTIFY
jne     WP_WM_DISPLAYCHANGE
; -------------------------------------------------------------------------
mov     ebx,WP_lParam 
mov     eax,[ebx+0]
cmp     eax,hWndLV
jne     WP_Return
;---
invoke  IsWindowEnabled,hWndBU_SaveComment
cmp     eax,0
je      WP_Return
;---
mov     eax,[ebx+8]
cmp     eax,NM_RCLICK
je      ListviewPopup
cmp     fMode,1
je      WP_Return
cmp     eax,NM_CLICK
je      ListViewAction
cmp     eax,NM_RETURN
je      ListViewAction
cmp     eax,LVN_KEYDOWN
je      ListViewKey
jmp     WP_Return
;---
ListviewPopup:
invoke  SendMessage,hWndLV,LVM_GETITEMCOUNT,0,0
cmp     eax,0
je      WP_Return
invoke  SetFocus,hWndLV
invoke  GetCursorPos,ADDR pt
invoke  TrackPopupMenuEx,hPopup,TPM_LEFTBUTTON,pt.x,pt.y,WP_hWnd,0
jmp     WP_Return
;---
ListViewKey:
mov     ax,[ebx+12]
cmp     ax,VK_UP
je      ListViewKeyUp
cmp     ax,VK_DOWN
je      ListViewKeyDown
jmp     WP_Return
;---
ListViewKeyUp:
invoke  SendMessage,hWndLV,LVM_GETITEMCOUNT,0,0
cmp     eax,0
je      WP_Return
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
dec     eax
call    SubLoadComment
jmp     WP_Return
;---
ListViewKeyDown:
invoke  SendMessage,hWndLV,LVM_GETITEMCOUNT,0,0
cmp     eax,0
je      WP_Return
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
inc     eax
call    SubLoadComment
jmp     WP_Return
;---
ListViewAction:
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
call    SubLoadComment
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DISPLAYCHANGE:
cmp     eax,WM_DISPLAYCHANGE
jne     WP_WM_NCMOUSEMOVE
; -------------------------------------------------------------------------
invoke  InvalidateRect,WP_hWnd,0,0
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_NCMOUSEMOVE:
cmp     eax,WM_NCMOUSEMOVE
jne     WP_WM_COMMAND
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_COMMAND:
cmp     eax,WM_COMMAND
jne     WP_WM_TIMER
; -------------------------------------------------------------------------
mov     eax,WP_wParam                           ; control or menu ID in ax
; -------------------------------------------------------------------------
WP_WM_COMMAND_PopupInsertSelected:
cmp     ax,1000
jne     WP_WM_COMMAND_PopupInsertSelectedLB
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferInsert
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,eax,ADDR lvi
cmp     fMode,0
je      WP_WM_COMMAND_PopupInsertSelectedGo
invoke  lstrcat,ADDR BufferInsert,ADDR szEqual
;---
WP_WM_COMMAND_PopupInsertSelectedGo:
call    SubInsertSelectedLVText
jmp     WP_Return
;---
WP_WM_COMMAND_PopupInsertSelectedLB:
cmp     ax,1001
jne     WP_WM_COMMAND_PopupInsertAll
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferInsert
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,eax,ADDR lvi
cmp     fMode,0
je      WP_WM_COMMAND_PopupInsertSelectedLBGo
invoke  lstrcat,ADDR BufferInsert,ADDR szEqual
;---
WP_WM_COMMAND_PopupInsertSelectedLBGo:
call    SubInsertSelectedLVTextLB
jmp     WP_Return
;---
WP_WM_COMMAND_PopupInsertAll:
cmp     ax,1002
jne     WP_WM_COMMAND_PopupInsertFromSelect
invoke  SendMessage,hWndLV,LVM_GETITEMCOUNT,0,0
cmp     eax,0
je      WP_Return
mov     ebx,eax
mov     counter,0
WP_WM_COMMAND_PopupInsertAllLoop:
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferInsert
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,counter,ADDR lvi
cmp     fMode,0
je      WP_WM_COMMAND_PopupInsertAllGo
invoke  lstrcat,ADDR BufferInsert,ADDR szEqual
;---
WP_WM_COMMAND_PopupInsertAllGo:
call    SubInsertSelectedLVTextLB
inc     counter
cmp     counter,ebx
jb      WP_WM_COMMAND_PopupInsertAllLoop
jmp     WP_Return
;---
WP_WM_COMMAND_PopupInsertFromSelect:
cmp     ax,1003
jne     WP_WM_COMMAND_PopupInsertNew
invoke  SendMessage,hWndLV,LVM_GETITEMCOUNT,0,0
cmp     eax,0
je      WP_Return
mov     ebx,eax
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
mov     counter,eax
WP_WM_COMMAND_PopupInsertFromSelectLoop:
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferInsert
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,counter,ADDR lvi
cmp     fMode,0
je      WP_WM_COMMAND_PopupInsertFromSelectGo
invoke  lstrcat,ADDR BufferInsert,ADDR szEqual
;---
WP_WM_COMMAND_PopupInsertFromSelectGo:
call    SubInsertSelectedLVTextLB
inc     counter
cmp     counter,ebx
jb      WP_WM_COMMAND_PopupInsertFromSelectLoop
jmp     WP_Return
;---
WP_WM_COMMAND_PopupInsertNew:
cmp     ax,1004
jne     WP_WM_COMMAND_PopupExecute
invoke  SendMessage,hWndLV,LVM_GETITEMCOUNT,0,0
cmp     eax,0
je      WP_Return
mov     ebx,eax
mov     counter,0
WP_WM_COMMAND_PopupInsertNewLoop:
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferInsert
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,counter,ADDR lvi
invoke  SendMessage,hWndED,EM_GETLINECOUNT,0,0
mov     esi,0
mov     edi,eax
;---
WP_WM_COMMAND_PopupInsertNewFind:
invoke  SendMessage,hWndED,EM_GETLINE,esi,ADDR BufferTmp
invoke  lstrlen,ADDR BufferInsert
invoke  CompareString,LOCALE_USER_DEFAULT,NORM_IGNORECASE,ADDR BufferInsert,eax,ADDR BufferTmp,eax
cmp     eax,CSTR_EQUAL
je      WP_WM_COMMAND_PopupInsertNewNext
inc     esi
cmp     esi,edi
jne     WP_WM_COMMAND_PopupInsertNewFind
cmp     fMode,0
je      WP_WM_COMMAND_PopupInsertNewGo
invoke  lstrcat,ADDR BufferInsert,ADDR szEqual
;---
WP_WM_COMMAND_PopupInsertNewGo:
call    SubInsertSelectedLVTextLB
;---
WP_WM_COMMAND_PopupInsertNewNext:
inc     counter
cmp     counter,ebx
jb      WP_WM_COMMAND_PopupInsertNewLoop
jmp     WP_Return
;---
WP_WM_COMMAND_PopupExecute:
cmp     ax,1005
jne     WP_WM_COMMAND_Path
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferLVText
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,eax,ADDR lvi
invoke  lstrcpy,ADDR BufferTmp,ADDR BufferPath
invoke  PathRemoveFileSpec,ADDR BufferTmp
invoke  PathAddBackslash,ADDR BufferTmp
invoke  SetWindowText,hWndSB,0
invoke  ShellExecute,WP_hWnd,ADDR szOpen,ADDR BufferLVText,0,ADDR BufferTmp,SW_SHOWNORMAL
cmp     eax,32
ja      WP_Return
call    SubGetLastError
jmp     WP_Return
;---
WP_WM_COMMAND_Path:
cmp     ax,1201
jne     WP_WM_COMMAND_InsertSymbol
call    SubFindFiles
jmp     WP_Return
;---
WP_WM_COMMAND_InsertSymbol:
cmp     ax,1202
jne     WP_WM_COMMAND_InsertCustom
call    SubInsertCBSymbol
jmp     WP_Return
;---
WP_WM_COMMAND_InsertCustom:
cmp     ax,1203
jne     WP_WM_COMMAND_SaveComment
call    SubInsertCBCustom
jmp     WP_Return
;---
WP_WM_COMMAND_SaveComment:
cmp     ax,1204
jne     WP_WM_COMMAND_ModeSingle
call    SubSaveComment
jmp     WP_Return
;---
WP_WM_COMMAND_ModeSingle:
cmp     ax,1205
jne     WP_WM_COMMAND_ModeMulti
cmp     fMode,0
je      WP_Return
mov     fMode,0
invoke  SendMessage,hWndLV,LVM_GETNEXTITEM,-1,LVIS_FOCUSED
cmp     eax,-1
je      WP_Return
call    SubLoadComment
jmp     WP_Return
;---
WP_WM_COMMAND_ModeMulti:
cmp     ax,1206
jne     WP_WM_COMMAND_DeleteCustom
cmp     fMode,1
je      WP_Return
mov     fMode,1
call    SubLoadComment
jmp     WP_Return
;---
WP_WM_COMMAND_DeleteCustom:
cmp     ax,1208
jne     WP_WM_COMMAND_DeleteDir
invoke  SendMessage,hWndCBCustom,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      WP_Return
mov     ebx,eax
invoke  SendMessage,hWndCBCustom,CB_DELETESTRING,ebx,0
cmp     eax,CB_ERR
je      WP_Return
invoke  SendMessage,hWndCBCustom,CB_GETCOUNT,0,0
cmp     eax,CB_ERR
je      WP_Return
dec     eax
cmp     ebx,eax
jbe     WP_WM_COMMAND_DeleteCustomEnd
dec     ebx
;---
WP_WM_COMMAND_DeleteCustomEnd:
invoke  SendMessage,hWndCBCustom,CB_SETCURSEL,ebx,0
jmp     WP_Return
;---

WP_WM_COMMAND_DeleteDir:
cmp     ax,1209
jne     WP_WM_COMMAND_CBDirCBN_SELCHANGE
invoke  SendMessage,hWndCBDir,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      WP_Return
mov     ebx,eax
invoke  SendMessage,hWndCBDir,CB_DELETESTRING,ebx,0
cmp     eax,CB_ERR
je      WP_Return
invoke  SendMessage,hWndCBDir,CB_GETCOUNT,0,0
cmp     eax,CB_ERR
je      WP_Return
dec     eax
cmp     ebx,eax
jbe     WP_WM_COMMAND_DeleteDirGo
dec     ebx
;---
WP_WM_COMMAND_DeleteDirGo:
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  SendMessage,hWndCBDir,CB_SETCURSEL,ebx,0
invoke  SendMessage,hWndCBDir,CB_GETLBTEXT,0,ADDR BufferTmp
cmp     eax,CB_ERR
je      WP_WM_COMMAND_DeleteDirEnd
cmp     eax,0
je      WP_WM_COMMAND_DeleteDirEnd
invoke  lstrcpy,ADDR BufferPath,ADDR BufferTmp
call    SubFindFilesGo
jmp     WP_Return
;---
WP_WM_COMMAND_DeleteDirEnd:
invoke  SendMessage,hWndLV,LVM_DELETEALLITEMS,0,0
invoke  SetWindowText,hWndED,0
mov     esi,0
call    SubFindFilesToogle
jmp     WP_Return
;---
WP_WM_COMMAND_CBDirCBN_SELCHANGE:
cmp     ax,1502
jne     WP_Return
mov     eax,WP_wParam
shr     eax,16
cmp     eax,CBN_SELCHANGE
jne     WP_Return
invoke  SendMessage,hWndCBDir,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      WP_Return
invoke  SendMessage,hWndCBDir,CB_GETLBTEXT,eax,ADDR BufferPath
call    SubFindFilesGo
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_TIMER:
cmp     eax,WM_TIMER
jne     WP_WM_CTLCOLORBTN
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORBTN:
cmp     eax,WM_CTLCOLORBTN
jne     WP_WM_CTLCOLORSTATIC
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLORSTATIC:
cmp     eax,WM_CTLCOLORSTATIC
jne     WP_WM_CTLCOLOREDIT
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CTLCOLOREDIT:
cmp     eax,WM_CTLCOLOREDIT
jne     WP_WM_CTLCOLORLISTBOX
; -------------------------------------------------------------------------
mov     eax,WP_lParam
cmp     eax,hWndED
jne     WP_Return
invoke  SetBkMode,WP_wParam,OPAQUE
invoke  SetBkColor,WP_wParam,0000D6FFh
invoke  SetTextColor,WP_wParam,0
mov     eax,hBr0000D6FFh
mov     ReturnEAX,eax
jmp     WP_ReturnEAX

; -------------------------------------------------------------------------
WP_WM_CTLCOLORLISTBOX:
cmp     eax,WM_CTLCOLORLISTBOX
jne     WP_WM_WINDOWPOSCHANGING
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_WINDOWPOSCHANGING:
cmp     eax,WM_WINDOWPOSCHANGING
jne     WP_WM_DRAWITEM
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_DRAWITEM:
cmp     eax,WM_DRAWITEM
jne     WP_WM_PARENTNOTIFY
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_PARENTNOTIFY:
cmp     eax,WM_PARENTNOTIFY
jne     WP_WM_RBUTTONDOWN
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_RBUTTONDOWN:
cmp     eax,WM_RBUTTONDOWN
jne     WP_WM_MOUSEMOVE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_MOUSEMOVE:
cmp     eax,WM_MOUSEMOVE
jne     WP_WM_CONTEXTMENU
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_CONTEXTMENU:
cmp     eax,WM_CONTEXTMENU
jne     WP_WM_POWERBROADCAST
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_POWERBROADCAST:
cmp     eax,WM_POWERBROADCAST
jne     WP_WM_ERASEBKGND
; -------------------------------------------------------------------------
mov     eax,WP_wParam
cmp     eax,PBT_APMRESUMESUSPEND
jne     WP_Return
mov     eax,WP_lParam
cmp     eax,PBTF_APMRESUMEFROMFAILURE
je      WP_Return
invoke  RedrawWindow,WP_hWnd,0,0,RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_ERASEBKGND:
cmp     eax,WM_ERASEBKGND
jne     WP_WM_ACTIVATE
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_ACTIVATE:
cmp     eax,WM_ACTIVATE
jne     WP_WM_HSCROLL
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_HSCROLL:
cmp     eax,WM_HSCROLL
jne     WP_WM_VSCROLL
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_VSCROLL:
cmp     eax,WM_VSCROLL
jne     WP_WM_SYNCPAINT
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_WM_SYNCPAINT:
cmp     eax,WM_SYNCPAINT
jne     WP_Return
; -------------------------------------------------------------------------

jmp     WP_Return

; -------------------------------------------------------------------------
WP_Return:
; -------------------------------------------------------------------------
popad
invoke  DefWindowProc,WP_hWnd,WP_uMsg,WP_wParam,WP_lParam
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return0:
; -------------------------------------------------------------------------
popad
mov     eax,0
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_Return1:
; -------------------------------------------------------------------------
popad
mov     eax,1
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------
WP_ReturnEAX:
; -------------------------------------------------------------------------
popad
mov     eax,ReturnEAX
mov     esp,ebp                                 ; delete stack frame
pop     ebp
ret     10h                                     ; return and clear stack
; -------------------------------------------------------------------------



; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; SubRoutines
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SubGetSystemMetrics:
invoke  GetSystemMetrics,SM_CXSCREEN
cmp     eax,XmaxWindow
jbe     SubGetSystemMetricsRet
shr     eax,1
mov     ebx,XmaxWindow
shr     ebx,1
sub     eax,ebx
mov     XorgWindow,eax
invoke  GetSystemMetrics,SM_CYSCREEN
cmp     eax,YmaxWindow
jbe     SubGetSystemMetricsRet
shr     eax,1
mov     ebx,YmaxWindow
shr     ebx,1
sub     eax,ebx
mov     YorgWindow,eax
;---
SubGetSystemMetricsRet:
ret
; -------------------------------------------------------------------------
SubUndo:
invoke  CloseClipboard
invoke  OpenClipboard,WP_hWnd
cmp     eax,0
je      SubUndoReturn
invoke  GlobalAlloc,GMEM_MOVEABLE,UseBufferTmp
mov     hMem,eax
invoke  GlobalLock,hMem
mov     pMem,eax
invoke  GetWindowText,hWndED,ADDR BufferTmp,UseBufferTmp
invoke  lstrcpy,pMem,ADDR BufferTmp
invoke  EmptyClipboard
invoke  GlobalUnlock,hMem
invoke  SetClipboardData,CF_TEXT,hMem
invoke  CloseClipboard
;---
SubUndoReturn:
ret
; -------------------------------------------------------------------------
SubCleanSystem:
invoke  ImageList_Destroy,hWndIL
invoke  DestroyWindow,hPopup
invoke  DestroyWindow,hWndLV
invoke  DestroyWindow,hWndED
invoke  DestroyWindow,hWndCBDir
invoke  DestroyWindow,hWndCBSymbol
invoke  DestroyWindow,hWndCBCustom
invoke  DestroyWindow,hWndBU_DeleteDir
invoke  DestroyWindow,hWndBU_Folder
invoke  DestroyWindow,hWndBU_InsertSymbol
invoke  DestroyWindow,hWndBU_InsertCustom
invoke  DestroyWindow,hWndBU_DeleteCustom
invoke  DestroyWindow,hWndBU_ModeSingle
invoke  DestroyWindow,hWndBU_ModeMulti
invoke  DestroyWindow,hWndBU_SaveComment
invoke  DestroyWindow,hWndBU_ModeBAK
invoke  DestroyWindow,hWndSB
invoke  DeleteObject,hBr0000D6FFh
ret
; -------------------------------------------------------------------------
SubCreateSysMenu:
invoke  GetSystemMenu,WP_hWnd,0
mov     hSysMenu,eax
invoke  AppendMenu,hSysMenu,MF_SEPARATOR,0,0
invoke  AppendMenu,hSysMenu,MF_STRING,1050,ADDR szHFSHome
invoke  AppendMenu,hSysMenu,MF_STRING,1051,ADDR szWarpHome
invoke  AppendMenu,hSysMenu,MF_SEPARATOR,0,0
invoke  AppendMenu,hSysMenu,MF_STRING,1052,ADDR szAbout
ret
; -------------------------------------------------------------------------
SubCreatePopupMenu:
invoke  CreatePopupMenu
mov     hPopup,eax
invoke  AppendMenu,hPopup,MF_STRING,1000,ADDR szInsertSelected
invoke  AppendMenu,hPopup,MF_STRING,1001,ADDR szInsertSelectedLB
invoke  AppendMenu,hPopup,MF_SEPARATOR,0,0
invoke  AppendMenu,hPopup,MF_STRING,1002,ADDR szInsertAll
invoke  AppendMenu,hPopup,MF_STRING,1003,ADDR szInsertFromSelect
invoke  AppendMenu,hPopup,MF_SEPARATOR,0,0
invoke  AppendMenu,hPopup,MF_STRING,1004,ADDR szInsertNew
invoke  AppendMenu,hPopup,MF_SEPARATOR,0,0
invoke  AppendMenu,hPopup,MF_STRING,1005,ADDR szExecuteFile
invoke  AppendMenu,hPopup,MF_SEPARATOR,0,0
invoke  AppendMenu,hPopup,MF_STRING,1009,ADDR szCancel
ret
; -------------------------------------------------------------------------
SubCreateLV:
invoke  CreateWindowEx,0,ADDR szCN_Listview,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or LVS_REPORT or LVS_NOCOLUMNHEADER or LVS_SHOWSELALWAYS or LVS_SINGLESEL or LVS_SORTASCENDING,8,32,576,192,WP_hWnd,1400,wc.hInstance,0
mov     hWndLV,eax
invoke  SendMessage,hWndLV,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndLV,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_DOUBLEBUFFER or LVS_EX_FLATSB or LVS_EX_FULLROWSELECT or LVS_EX_ONECLICKACTIVATE
invoke  SendMessage,hWndLV,LVM_SETBKCOLOR,0,00FFD600h
invoke  SendMessage,hWndLV,LVM_SETTEXTBKCOLOR,0,CLR_NONE
invoke  SendMessage,hWndLV,LVM_SETTEXTCOLOR,0,00000000h
mov     lvc.imask,LVCF_WIDTH or LVCF_FMT
mov     lvc.fmt,LVCFMT_LEFT
mov     lvc.lx,576
invoke  SendMessage,hWndLV,LVM_INSERTCOLUMN,0,ADDR lvc
mov     lvi.imask,LVIF_TEXT
mov     lvi.iSubItem,0
mov     eax,OFFSET szAttention0
mov     lvi.pszText,eax
mov     lvi.iItem,0
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
mov     eax,OFFSET szAttention1
mov     lvi.pszText,eax
mov     lvi.iItem,1
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
mov     eax,OFFSET szAttention2
mov     lvi.pszText,eax
mov     lvi.iItem,1
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
mov     eax,OFFSET szAttention3
mov     lvi.pszText,eax
mov     lvi.iItem,2
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
mov     eax,OFFSET szAttention4
mov     lvi.pszText,eax
mov     lvi.iItem,3
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
mov     eax,OFFSET szAttention5
mov     lvi.pszText,eax
mov     lvi.iItem,4
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
;invoke  ImageList_Create,10h,10h,ILC_MASK or ILC_COLOR8,0,1000h                ;remove ";" to enable icons
;mov     hWndIL,eax
;invoke  SendMessage,hWndLV,LVM_SETIMAGELIST,LVSIL_SMALL,hWndIL
ret
; -------------------------------------------------------------------------
SubCreateCBCustom:
invoke  CreateWindowEx,0,ADDR szCN_Combobox,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or WS_BORDER or WS_VSCROLL or CBS_SORT or CBS_NOINTEGRALHEIGHT or CBS_DROPDOWNLIST,8,231,576,234,WP_hWnd,1500,wc.hInstance,0
mov     hWndCBCustom,eax
invoke  SendMessage,hWndCBCustom,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndCBCustom,CB_SETCURSEL,0,0
ret
; -------------------------------------------------------------------------
SubCreateCBSymbol:
invoke  CreateWindowEx,0,ADDR szCN_Combobox,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or WS_BORDER or WS_VSCROLL or CBS_SORT or CBS_NOINTEGRALHEIGHT or CBS_DROPDOWNLIST,592,34,116,158,WP_hWnd,1501,wc.hInstance,0
mov     hWndCBSymbol,eax
invoke  SendMessage,hWndCBSymbol,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szbuildtime
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szcomment
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szconnections
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szcontent
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szdiskfree
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szdonebytes
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szencodedfolder
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szfilename
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szfiles
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szfolder
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szhost
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szidx
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szip
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemadded
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemarchivable
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemcomment
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemdlcount
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemext
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemmodified
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemname
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemsize
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemsizeb
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemsizekb
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szitemurl
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szlist
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szloggedin
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szloginlink
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznew
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznumber
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznumberaddresses
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznumberaddrdownloa
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznumberaddressesev
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznumberfiles
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sznumberfolders
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szparentfolder
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szperc
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szprogressfiles
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szreason
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szsequential
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szspeedin
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szspeedkb
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szspeedout
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szstyle
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sztimestamp
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sztotalbytes
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sztotalin
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sztotalout
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR sztotalsize
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szup
;invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szuploadfiles
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szuploadlink
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szuptime
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szuser
invoke  SendMessage,hWndCBSymbol,CB_ADDSTRING,0,ADDR szversion
invoke  SendMessage,hWndCBSymbol,CB_SETCURSEL,0,0
ret
; -------------------------------------------------------------------------
SubCreateCBDir:
invoke  CreateWindowEx,0,ADDR szCN_Combobox,0,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or WS_VSCROLL or CBS_SORT or CBS_NOINTEGRALHEIGHT or CBS_DROPDOWNLIST,8,6,576,130,WP_hWnd,1502,wc.hInstance,0
mov     hWndCBDir,eax
invoke  SendMessage,hWndCBDir,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndCBDir,CB_SETCURSEL,0,0
ret
; -------------------------------------------------------------------------
SubCreateEdit:
invoke  CreateWindowEx,0,ADDR szCN_Edit,0,WS_CHILD or WS_VISIBLE or WS_VSCROLL or WS_HSCROLL or WS_CLIPSIBLINGS or WS_BORDER or ES_LEFT or ES_MULTILINE or ES_AUTOVSCROLL or ES_AUTOHSCROLL,8,260,576,196,WP_hWnd,1300,wc.hInstance,0
mov     hWndED,eax
invoke  SendMessage,hWndED,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndED,EM_LIMITTEXT,MaxBufferTmp,0
ret
; -------------------------------------------------------------------------
SubCreateBU_Folder:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szSelectFolder,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or BS_FLAT,592,4,72,24,WP_hWnd,1201,wc.hInstance,0
mov     hWndBU_Folder,eax
invoke  SendMessage,hWndBU_Folder,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_InsertSymbol:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szInsertSymbol,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_FLAT,592,200,116,24,WP_hWnd,1202,wc.hInstance,0
mov     hWndBU_InsertSymbol,eax
invoke  SendMessage,hWndBU_InsertSymbol,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_InsertCustom:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szInsertCustom,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_FLAT,592,230,72,24,WP_hWnd,1203,wc.hInstance,0
mov     hWndBU_InsertCustom,eax
invoke  SendMessage,hWndBU_InsertCustom,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_SaveComment:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szSaveComment,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_FLAT,592,352,116,32,WP_hWnd,1204,wc.hInstance,0
mov     hWndBU_SaveComment,eax
invoke  SendMessage,hWndBU_SaveComment,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_ModeSingle:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szModeSingle,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or WS_GROUP or BS_AUTORADIOBUTTON,596,280,116,20,WP_hWnd,1205,wc.hInstance,0
mov     hWndBU_ModeSingle,eax
invoke  SendMessage,hWndBU_ModeSingle,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_ModeMulti:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szModeMulti,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_AUTORADIOBUTTON,596,310,116,20,WP_hWnd,1206,wc.hInstance,0
mov     hWndBU_ModeMulti,eax
invoke  SendMessage,hWndBU_ModeMulti,WM_SETFONT,hFntDefGui,1h
invoke  SendMessage,hWndBU_ModeMulti,BM_SETCHECK,BST_CHECKED,0
mov     fMode,1
ret
; -------------------------------------------------------------------------
SubCreateBU_ModeBAK:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szModeBAK,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_AUTOCHECKBOX,594,408,116,20,WP_hWnd,1207,wc.hInstance,0
mov     hWndBU_ModeBAK,eax
invoke  SendMessage,hWndBU_ModeBAK,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_DeleteCustom:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szDelete,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_FLAT,668,230,40,24,WP_hWnd,1208,wc.hInstance,0
mov     hWndBU_DeleteCustom,eax
invoke  SendMessage,hWndBU_DeleteCustom,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateBU_DeleteDir:
invoke  CreateWindowEx,0,ADDR szCN_Button,ADDR szDelete,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DISABLED or BS_FLAT,668,4,40,24,WP_hWnd,1209,wc.hInstance,0
mov     hWndBU_DeleteDir,eax
invoke  SendMessage,hWndBU_DeleteDir,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubCreateSB:
invoke  CreateWindowEx,0,ADDR szCN_Statusbar,ADDR szAboutText,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS,0,496,720,24,WP_hWnd,1100,wc.hInstance,0
mov     hWndSB,eax
invoke  SendMessage,hWndSB,WM_SETFONT,hFntDefGui,1h
ret
; -------------------------------------------------------------------------
SubInsertSelectedLVTextLB:
invoke  lstrcat,ADDR BufferInsert,ADDR szLineBreak
;---
SubInsertSelectedLVText:
invoke  GetWindowText,hWndED,ADDR BufferTmp,UseBufferTmp
invoke  GetWindowText,hWndED,ADDR BufferTmp1,UseBufferTmp
invoke  SendMessage,hWndED,EM_GETSEL,0,0
and     eax,0FFFFh
mov     edi,OFFSET BufferTmp
add     edi,eax
mov     esi,OFFSET BufferTmp1
add     esi,eax
mov     dl,0
mov     [edi],dl
invoke  lstrcat,ADDR BufferTmp,ADDR BufferInsert
invoke  lstrlen,ADDR BufferTmp
mov     edi,eax
invoke  lstrcat,ADDR BufferTmp,esi
invoke  SetWindowText,hWndED,ADDR BufferTmp
invoke  SendMessage,hWndED,EM_SETSEL,edi,edi
invoke  SendMessage,hWndED,EM_SCROLLCARET,0,0
ret
; -------------------------------------------------------------------------
SubInsertCBSymbol:
invoke  SendMessage,hWndCBSymbol,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      SubInsertCBSymbolReturn
invoke  SendMessage,hWndCBSymbol,CB_GETLBTEXT,eax,ADDR BufferInsert
invoke  GetWindowText,hWndED,ADDR BufferTmp,UseBufferTmp
invoke  GetWindowText,hWndED,ADDR BufferTmp1,UseBufferTmp
invoke  SendMessage,hWndED,EM_GETSEL,0,0
and     eax,0FFFFh
mov     edi,OFFSET BufferTmp
add     edi,eax
mov     esi,OFFSET BufferTmp1
add     esi,eax
mov     dl,0
mov     [edi],dl
invoke  lstrcat,ADDR BufferTmp,ADDR BufferInsert
invoke  lstrlen,ADDR BufferTmp
mov     edi,eax
invoke  lstrcat,ADDR BufferTmp,esi
invoke  SetWindowText,hWndED,ADDR BufferTmp
invoke  SendMessage,hWndED,EM_SETSEL,edi,edi
invoke  SendMessage,hWndED,EM_SCROLLCARET,0,0
;---
SubInsertCBSymbolReturn:
ret
; -------------------------------------------------------------------------
SubInsertCBCustom:
invoke  SendMessage,hWndCBCustom,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
je      SubInsertCBCustomReturn
invoke  SendMessage,hWndCBCustom,CB_GETLBTEXT,eax,ADDR BufferInsert
invoke  GetWindowText,hWndED,ADDR BufferTmp,UseBufferTmp
invoke  GetWindowText,hWndED,ADDR BufferTmp1,UseBufferTmp
invoke  SendMessage,hWndED,EM_GETSEL,0,0
and     eax,0FFFFh
mov     edi,OFFSET BufferTmp
add     edi,eax
mov     esi,OFFSET BufferTmp1
add     esi,eax
mov     dl,0
mov     [edi],dl
invoke  lstrcat,ADDR BufferTmp,ADDR BufferInsert
invoke  lstrlen,ADDR BufferTmp
mov     edi,eax
invoke  lstrcat,ADDR BufferTmp,esi
invoke  SetWindowText,hWndED,ADDR BufferTmp
invoke  SendMessage,hWndED,EM_SETSEL,edi,edi
invoke  SendMessage,hWndED,EM_SCROLLCARET,0,0
;---
SubInsertCBCustomReturn:
ret
; -------------------------------------------------------------------------
SubFindFiles:
mov     eax,WP_hWnd
mov     bi.hwndOwner,eax
mov     bi.pidlRoot,CSIDL_DESKTOP
mov     bi.pszDisplayName,OFFSET BufferTmp
mov     bi.lpszTitle,OFFSET szSelectFolder
mov     bi.ulFlags,BIF_BROWSEINCLUDEURLS or BIF_RETURNONLYFSDIRS
invoke  SHBrowseForFolder,ADDR bi
cmp     eax,0h
je      SubFindFilesReturn
invoke  SHGetPathFromIDList,eax,ADDR BufferPath
cmp     eax,1
jne     SubFindFilesReturn
invoke  SendMessage,hWndCBDir,CB_FINDSTRINGEXACT,-1,ADDR BufferPath
cmp     eax,CB_ERR
jne     SubFindFilesGo
invoke  SendMessage,hWndCBDir,CB_ADDSTRING,0,ADDR BufferPath
cmp     eax,CB_ERR
je      SubFindFilesReturn
cmp     eax,CB_ERRSPACE
je      SubFindFilesReturn
invoke  SendMessage,hWndCBDir,CB_FINDSTRINGEXACT,-1,ADDR BufferPath
cmp     eax,CB_ERR
je      SubFindFilesReturn
invoke  SendMessage,hWndCBDir,CB_SETCURSEL,eax,0
;---
SubFindFilesGo:
invoke  lstrcat,ADDR BufferPath,ADDR szWildCtrl
mov     esi,0
mov     edi,0
mov     hFindFile,0
invoke  FindFirstFile,ADDR BufferPath,ADDR wfd
cmp     eax,INVALID_HANDLE_VALUE
je      SubFindFilesReturn
mov     hFindFile,eax
invoke  SendMessage,hWndLV,LVM_DELETEALLITEMS,0,0
invoke  SetWindowText,hWndED,0
;---
SubFindFilesLoop:
and     wfd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
jne     SubFindFilesNext
invoke  PathFindExtension,ADDR wfd.cFileName
mov     ebx,eax
invoke  CompareString,LOCALE_USER_DEFAULT,NORM_IGNORECASE,ADDR szExtensionComment,-1,ebx,-1
cmp     eax,CSTR_EQUAL
je      SubFindFilesNext
invoke  CompareString,LOCALE_USER_DEFAULT,NORM_IGNORECASE,ADDR szExtensionCommentB,-1,ebx,-1
cmp     eax,CSTR_EQUAL
je      SubFindFilesNext
invoke  CompareString,LOCALE_USER_DEFAULT,NORM_IGNORECASE,ADDR szhfscommentstxt,-1,ADDR wfd.cFileName,-1
cmp     eax,CSTR_EQUAL
je      SubFindFilesNext
invoke  CompareString,LOCALE_USER_DEFAULT,NORM_IGNORECASE,ADDR szhfscommentstxtB,-1,ADDR wfd.cFileName,-1
cmp     eax,CSTR_EQUAL
je      SubFindFilesNext
invoke  lstrcpy,ADDR BufferTmp,ADDR wfd.cFileName
mov     lvi.imask,LVIF_TEXT
;mov     IconIndex,0                                                            ;remove ";" to enable icons
;invoke  ExtractAssociatedIcon,wc.hInstance,ADDR BufferTmp,ADDR IconIndex
;mov     esi,eax
;cmp     eax,0
;je      SubFindFilesIcon
;invoke  ImageList_ReplaceIcon,hWndIL,-1,eax
;mov     lvi.iImage,eax
;invoke  DeleteObject,esi
;or      lvi.imask,LVIF_IMAGE
;---
SubFindFilesIcon:
mov     ebx,OFFSET wfd.cFileName
mov     lvi.pszText,ebx
mov     lvi.iSubItem,0
mov     eax,edi
mov     lvi.iItem,eax
invoke  SendMessage,hWndLV,LVM_INSERTITEM,0,ADDR lvi
inc     edi
SubFindFilesNext:
invoke  FindNextFile,hFindFile,ADDR wfd.dwFileAttributes
cmp     eax,1h
je      SubFindFilesLoop
invoke  FindClose,hFindFile
;---
SubFindFilesClose:
mov     lvi.state,LVIS_FOCUSED or LVIS_SELECTED
mov     lvi.stateMask,LVIS_FOCUSED or LVIS_SELECTED
invoke  SendMessage,hWndLV,LVM_SETITEMSTATE,0,ADDR lvi
mov     eax,0
call    SubLoadComment
mov     esi,0
cmp     edi,0
je      SubFindFilesToogle
mov     esi,1
;---
SubFindFilesToogle:
invoke  EnableWindow,hWndBU_InsertSymbol,esi
invoke  EnableWindow,hWndBU_InsertCustom,esi
invoke  EnableWindow,hWndBU_DeleteDir,esi
invoke  EnableWindow,hWndBU_DeleteCustom,esi
invoke  EnableWindow,hWndBU_SaveComment,esi
invoke  EnableWindow,hWndBU_ModeSingle,esi
invoke  EnableWindow,hWndBU_ModeMulti,esi
invoke  EnableWindow,hWndBU_ModeBAK,esi
invoke  EnableWindow,hWndCBSymbol,esi
invoke  EnableWindow,hWndCBCustom,esi
;---
SubFindFilesReturn:
ret
; -------------------------------------------------------------------------
SubLoadComment:
cmp     fMode,0
je      SubLoadCommentSingle
cmp     fMode,1
je      SubLoadCommentMulti
ret
;---
SubLoadCommentSingle:
mov     lvi.iSubItem,0
mov     lvi.pszText,OFFSET BufferLVText
mov     lvi.cchTextMax,MAX_PATH
invoke  SendMessage,hWndLV,LVM_GETITEMTEXT,eax,ADDR lvi
invoke  lstrcpy,ADDR BufferPathFile,ADDR BufferPath
invoke  PathRemoveFileSpec,ADDR BufferPathFile
invoke  PathAddBackslash,ADDR BufferPathFile
invoke  lstrcat,ADDR BufferPathFile,ADDR BufferLVText
invoke  lstrcat,ADDR BufferPathFile,ADDR szExtensionComment
jmp     SubLoadCommentGo
;---
SubLoadCommentMulti:
invoke  lstrcpy,ADDR BufferPathFile,ADDR BufferPath
invoke  PathRemoveFileSpec,ADDR BufferPathFile
invoke  PathAddBackslash,ADDR BufferPathFile
invoke  lstrcat,ADDR BufferPathFile,ADDR szhfscommentstxt
jmp     SubLoadCommentGo
;---
SubLoadCommentGo:
call    SubUndo
invoke  SetWindowText,hWndED,0
invoke  SetWindowText,hWndSB,0
invoke  CreateFile,ADDR BufferPathFile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
invoke  GetFileSize,hFile,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
cmp     eax,0
je      SubErrorFilesize
cmp     eax,UseBufferTmp
ja      SubErrorFilesize
mov     FileBytesTotal,eax
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  ReadFile,hFile,ADDR BufferTmp,FileBytesTotal,ADDR FileBytesRead,0
cmp     eax,0
je      SubGetLastError
invoke  CloseHandle,hFile
invoke  SetWindowText,hWndED,ADDR BufferTmp
call    SubUpdateCBCustom
;---
SubLoadCommentReturn:
ret
; -------------------------------------------------------------------------
SubSaveComment:
call    SubUpdateCBCustom
cmp     fMode,0
je      SubSaveCommentSingle
cmp     fMode,1
je      SubSaveCommentMulti
ret
;---
SubSaveCommentSingle:
invoke  lstrcpy,ADDR BufferPathFile,ADDR BufferPath
invoke  PathRemoveFileSpec,ADDR BufferPathFile
invoke  PathAddBackslash,ADDR BufferPathFile
invoke  lstrcat,ADDR BufferPathFile,ADDR BufferLVText
invoke  lstrcat,ADDR BufferPathFile,ADDR szExtensionComment
invoke  SendMessage,hWndBU_ModeBAK,BM_GETCHECK,0,0
cmp     eax,BST_CHECKED
jne     SubSaveCommentSingleGo
invoke  lstrcpy,ADDR BufferTmp,ADDR BufferPathFile
invoke  lstrcat,ADDR BufferTmp,ADDR szBAK
invoke  CopyFile,ADDR BufferPathFile,ADDR BufferTmp,0
;---
SubSaveCommentSingleGo:
invoke  SetWindowText,hWndSB,0
invoke  CreateFile,ADDR BufferPathFile,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  GetWindowText,hWndED,ADDR BufferTmp,UseBufferTmp
invoke  lstrlen,ADDR BufferTmp
mov     FileBytesTotal,eax
invoke  WriteFile,hFile,ADDR BufferTmp,FileBytesTotal,ADDR FileBytesWrite,0
cmp     eax,0
je      SubGetLastError
invoke  CloseHandle,hFile
ret
; -------------------------------------------------------------------------
SubSaveCommentMulti:
invoke  lstrcpy,ADDR BufferPathFile,ADDR BufferPath
invoke  PathRemoveFileSpec,ADDR BufferPathFile
invoke  PathAddBackslash,ADDR BufferPathFile
invoke  lstrcat,ADDR BufferPathFile,ADDR szhfscommentstxt
invoke  SendMessage,hWndBU_ModeBAK,BM_GETCHECK,0,0
cmp     eax,BST_CHECKED
jne     SubSaveCommentMultiGo
invoke  lstrcpy,ADDR BufferTmp,ADDR BufferPathFile
invoke  lstrcat,ADDR BufferTmp,ADDR szBAK
invoke  CopyFile,ADDR BufferPathFile,ADDR BufferTmp,0
;---
SubSaveCommentMultiGo:
invoke  SetWindowText,hWndSB,0
invoke  CreateFile,ADDR BufferPathFile,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  GetWindowText,hWndED,ADDR BufferTmp,UseBufferTmp
invoke  lstrlen,ADDR BufferTmp
mov     FileBytesTotal,eax
invoke  WriteFile,hFile,ADDR BufferTmp,FileBytesTotal,ADDR FileBytesWrite,0
cmp     eax,0
je      SubGetLastError
invoke  CloseHandle,hFile
ret
; -------------------------------------------------------------------------
SubUpdateCBCustom:
invoke  SendMessage,hWndED,EM_GETLINECOUNT,0,0
mov     ebx,eax
mov     esi,0
;---
SubUpdateCBCustomCommentLoop:
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
mov     eax,UseBufferTmp
mov     edx,OFFSET BufferTmp
mov     [edx+0],ah
mov     [edx+1],al
invoke  SendMessage,hWndED,EM_GETLINE,esi,ADDR BufferTmp
cmp     eax,0
je      SubUpdateCBCustomReturn
mov     edi,OFFSET BufferTmp
cmp     fMode,0
je      SubUpdateCBCustomCommentFoundSingle
mov     edx,0D0A003Dh
;---
SubUpdateCBCustomCommentSearch:
cmp     [edi],dl
je      SubUpdateCBCustomCommentFoundMultiple
inc     edi
dec     eax
cmp     eax,0
jne     SubUpdateCBCustomCommentSearch
jmp     SubUpdateCBCustomCommentNext
;---
SubUpdateCBCustomCommentFoundMultiple:
inc     edi
cmp     [edi],dh
je      SubUpdateCBCustomCommentNext
shr     edx,16
cmp     [edi],dh
je      SubUpdateCBCustomCommentNext
cmp     [edi],dl
je      SubUpdateCBCustomCommentNext
;---
SubUpdateCBCustomCommentFoundSingle:
invoke  SendMessage,hWndCBCustom,CB_FINDSTRINGEXACT,-1,edi
cmp     eax,CB_ERR
jne     SubUpdateCBCustomCommentNext
invoke  SendMessage,hWndCBCustom,CB_ADDSTRING,0,edi
;---
SubUpdateCBCustomCommentNext:
inc     esi
dec     ebx
cmp     ebx,0
jne     SubUpdateCBCustomCommentLoop
invoke  SendMessage,hWndCBCustom,CB_GETCURSEL,0,0
cmp     eax,CB_ERR
jne     SubUpdateCBCustomReturn
invoke  SendMessage,hWndCBCustom,CB_SETCURSEL,0,0
;---
SubUpdateCBCustomReturn:
ret
; -------------------------------------------------------------------------
SubLoadDir:
invoke  CreateFile,ADDR BufferProgramDir,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
invoke  GetFileSize,hFile,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
cmp     eax,0
je      SubErrorFilesize
cmp     eax,UseBufferTmp
ja      SubErrorFilesize
mov     FileBytesTotal,eax
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  ReadFile,hFile,ADDR BufferTmp,FileBytesTotal,ADDR FileBytesRead,0
cmp     eax,0
je      SubGetLastError
cmp     FileBytesRead,0
je      SubErrorFilesize
invoke  CloseHandle,hFile
;---
mov     ebx,0
mov     esi,OFFSET BufferTmp
mov     edi,OFFSET BufferTmp
;---
SubLoadDirLoop:
mov     dx,0D0Ah
cmp     [edi+0],dh
jne     SubLoadDirNext
cmp     [edi+1],dl
jne     SubLoadDirNext
mov     eax,0
mov     [edi],al
invoke  SendMessage,hWndCBDir,CB_ADDSTRING,0,esi
add     edi,2
add     ebx,2
mov     esi,edi
cmp     ebx,FileBytesRead
jb      SubLoadDirLoop
jmp     SubLoadDirReturn
;---
SubLoadDirNext:
inc     edi
inc     ebx
cmp     ebx,FileBytesRead
jb      SubLoadDirLoop
cmp     esi,edi
jae     SubLoadDirReturn
invoke  SendMessage,hWndCBDir,CB_ADDSTRING,0,esi
;---
SubLoadDirReturn:
invoke  CloseHandle,hFile
invoke  SendMessage,hWndCBDir,CB_SETCURSEL,0,0
invoke  SendMessage,hWndCBDir,CB_GETLBTEXT,0,ADDR BufferTmp
;cmp     eax,CB_ERR
;je      SubLoadDirReturn
invoke  lstrcpy,ADDR BufferPath,ADDR BufferTmp
call    SubFindFilesGo
ret
; -------------------------------------------------------------------------
SubSaveDir:
invoke  DeleteFile,ADDR BufferProgramDir
invoke  SendMessage,hWndCBDir,CB_GETCOUNT,0,0
cmp     eax,CB_ERR
je      SubSaveDirReturn
cmp     eax,0
je      SubSaveDirReturn
mov     esi,eax
mov     ebx,0
;---
invoke  CreateFile,ADDR BufferProgramDir,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
;---
SubSaveDirLoop:
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  SendMessage,hWndCBDir,CB_GETLBTEXT,ebx,ADDR BufferTmp
cmp     eax,CB_ERR
je      SubSaveDirReturn
mov     ecx,esi
dec     ecx
cmp     ecx,ebx
je      SubSaveDirSkip
invoke  lstrcat,ADDR BufferTmp,ADDR szLineBreak
;---
SubSaveDirSkip:
invoke  lstrlen,ADDR BufferTmp
invoke  WriteFile,hFile,ADDR BufferTmp,eax,ADDR FileBytesWrite,0
cmp     eax,0
je      SubGetLastError
inc     ebx
cmp     ebx,esi
jne     SubSaveDirLoop
;---
SubSaveDirReturn:
invoke  CloseHandle,hFile
ret
; -------------------------------------------------------------------------
SubLoadFuc:
invoke  CreateFile,ADDR BufferProgramFuc,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
invoke  GetFileSize,hFile,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
cmp     eax,0
je      SubErrorFilesize
cmp     eax,UseBufferTmp
ja      SubErrorFilesize
mov     FileBytesTotal,eax
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  ReadFile,hFile,ADDR BufferTmp,FileBytesTotal,ADDR FileBytesRead,0
cmp     eax,0
je      SubGetLastError
cmp     FileBytesRead,0
je      SubErrorFilesize
invoke  CloseHandle,hFile
;---
mov     ebx,0
mov     esi,OFFSET BufferTmp
mov     edi,OFFSET BufferTmp
;---
SubLoadFucLoop:
mov     dx,0D0Ah
cmp     [edi+0],dh
jne     SubLoadFucNext
cmp     [edi+1],dl
jne     SubLoadFucNext
mov     eax,0
mov     [edi],al
invoke  SendMessage,hWndCBCustom,CB_ADDSTRING,0,esi
add     edi,2
add     ebx,2
mov     esi,edi
cmp     ebx,FileBytesRead
jb      SubLoadFucLoop
jmp     SubLoadFucReturn
;---
SubLoadFucNext:
inc     edi
inc     ebx
cmp     ebx,FileBytesRead
jb      SubLoadFucLoop
cmp     esi,edi
jae     SubLoadFucReturn
invoke  SendMessage,hWndCBCustom,CB_ADDSTRING,0,esi
;---
SubLoadFucReturn:
invoke  CloseHandle,hFile
invoke  SendMessage,hWndCBCustom,CB_SETCURSEL,0,0
ret
; -------------------------------------------------------------------------
SubSaveFuc:
invoke  DeleteFile,ADDR BufferProgramFuc
invoke  SendMessage,hWndCBCustom,CB_GETCOUNT,0,0
cmp     eax,CB_ERR
je      SubSaveFucReturn
cmp     eax,0
je      SubSaveFucReturn
mov     esi,eax
mov     ebx,0
;---
invoke  CreateFile,ADDR BufferProgramFuc,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
cmp     eax,INVALID_HANDLE_VALUE
je      SubGetLastError
mov     hFile,eax
;---
SubSaveFucLoop:
invoke  RtlZeroMemory,ADDR BufferTmp,MaxBufferTmp
invoke  SendMessage,hWndCBCustom,CB_GETLBTEXT,ebx,ADDR BufferTmp
cmp     eax,CB_ERR
je      SubSaveFucReturn
mov     ecx,esi
dec     ecx
cmp     ecx,ebx
je      SubSaveFucSkip
invoke  lstrcat,ADDR BufferTmp,ADDR szLineBreak
;---
SubSaveFucSkip:
invoke  lstrlen,ADDR BufferTmp
invoke  WriteFile,hFile,ADDR BufferTmp,eax,ADDR FileBytesWrite,0
cmp     eax,0
je      SubGetLastError
inc     ebx
cmp     ebx,esi
jne     SubSaveFucLoop
;---
SubSaveFucReturn:
invoke  CloseHandle,hFile
ret
; -------------------------------------------------------------------------
SubGetLastError:
invoke  GetLastError
invoke  FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,0,eax,0,ADDR BufferTmp,MAX_PATHEX,0
invoke  CloseHandle,hFile
invoke  SetWindowText,hWndSB,ADDR BufferTmp
ret
; -------------------------------------------------------------------------
SubErrorFilesize:
invoke  CloseHandle,hFile
invoke  SetWindowText,hWndSB,ADDR szErrorFileSize
ret

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
end Main
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

